Ofcas.Lk.Api.Client - Version 3.0 3.0.0.113

Public Member Functions | Public Attributes | Protected Member Functions | List of all members
Ofcas.Lk.Api.Client.Ui.ProjectCenterUi Class Reference

ProjectCenterUi is the representation of a LogiKal project-center. The ProjectCenterUi provides methods with user interactions. The children are of type Project. The children can be received from the InfoList (CoreObjectWithChildren<TChild,TChildInfo>.ChildrenInfos). Each ProjectCenter project center belongs to a fixed directory. To use another project directory, create a new project center using method ProjectCenter.GetProjectCenter. More...

Inheritance diagram for Ofcas.Lk.Api.Client.Ui.ProjectCenterUi:

## Public Member Functions
ProjectInfo | CreateChild ()
| Creates a new project with a default name and opens. Call Project.Edit with WellKnownEditKeys.Project.Name to change the name after the creation. Due to settings in LogiKal user interfaces can be shown. More...
new ProjectUi | GetChild (ProjectInfo projectInfo)
| Gets a ProjectUi based on a ProjectInfo. More...
new ProjectUi | GetProject (ProjectInfo projectInfo)
| This method is deprecated. Please use GetChild(ProjectInfo) instead. More...
void | SetApplicationHandle (IntPtr uiHandle)
| Sets an ui handle. All opened user interfaces used this handle as parent. After an operation the default handle from the login scope will be used (ServiceProxyBase<TService,TCoreObject>.Login). More...
new ProjectCenterUi | GetProjectCenter (ProjectDirectoryInfo projectDirectoryInfo)
| Creates a new ProjectCenterUi for the given directory. Each ProjectCenterUi belongs to a fixed directory. More...
ProjectInfo | CreateLkProject ()
| This method is obsolete, please use CanCreateChild() and CreateChild() instead and use the project programs to open the UI. See WellKnownPrograms.Project. More...
ProjectInfo | Import (ProjectCenterImportType importType, Stream content)
| Import a Project via User Interface (UI). More...
IDialogResult< Stream > | ExportChild (ProjectInfo projectInfo)
| Exports a Project based on its ProjectInfo via User Interface (UI). More...
IDialogResult< ProjectInfo > | ImportChild (Stream content)
| Imports a project from the provided content. It is possible to import a project with a *.LOB file (ExportChild. Additional formats to import are specified in the "Public API Documentation" (Confluence). More...
new Stream | ExportChild (ProjectInfo projectInfo, IEnumerable< ElevationInfo > elevationInfos, Dictionary< string, object > parameters)
| Exports a Project based on its ProjectInfo, list of ElevationInfo and parameters. More...
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.ProjectCenter
override Project | GetChild (ProjectInfo projectInfo)
| Gets a Project based on a ProjectInfo. More...
Project | GetProject (ProjectInfo projectInfo)
| This method is deprecated. Please use GetChild(ProjectInfo) instead. More...
ProjectCenter | GetProjectCenter (ProjectDirectoryInfo projectDirectoryInfo)
| Creates a new ProjectCenter for the given directory. Each ProjectCenter belongs to a fixed directory. More...
override OperationInfo | CanCreateChild ()
| Checks whether a project can be created or not. More...
override ProjectInfo | CreateChild ()
| Creates a new project with a default name. Call Project.Edit with WellKnownEditKeys.Project.Name to change the name after the creation. More...
override OperationInfo | CanDeleteChild (ProjectInfo projectInfo)
| Checks whether a project can be deleted or not. More...
override void | DeleteChild (ProjectInfo projectInfo, bool forceDelete=false)
| Deletes a project based on an info object. More...
override OperationInfo | CanMoveFrom (ICoreInfo coreInfo, bool deepCheck=true)
override ProjectInfo | MoveFrom (ICoreInfo coreInfo)
| Moves an object into this directory based on an info object. More...
override OperationInfo | CanCopyFrom (ICoreInfo coreInfo, bool deepCheck=true)
override ProjectInfo | CopyFrom (ICoreInfo coreInfo)
| Copies an object into this directory based on an info object. More...
ProjectInfo | CreateLkProject (string projectName)
| Creates a new Project in the LogiKal project structure. The project will be created in the current active directory. More...
Elevation | GetElevationFromLkId (Guid lkElevGuid)
  | Exceptions
  NotSupportedException |
ElevationInstance | GetElevationInstanceFromLkId (Guid lkElevInstanceGuid)
  | Exceptions
  NotSupportedException |
ProjectDirectoryInfo | CreateDirectory (string directoryName)
| Creates a new directory in the current project center. More...
OperationInfo | CanDeleteDirectory (string directoryName)
| Checks whether a directory can be deleted or not. More...
void | DeleteDirectory (string directoryName)
| Deletes the directory from the current project center. More...
OperationInfo | CanRename (string directoryName)
| Checks if the name of this project directory can be changed to the stated name. Renaming the root directory or the recyclebin is not possible. More...
ProjectDirectoryInfo | Rename (string directoryName)
| Changes the name of this project directory to the stated name. Renaming the root directory or the recyclebin is not possible. More...
Stream | ExportChild (ProjectInfo projectInfo, IEnumerable< ElevationInfo > elevationInfos, Dictionary< string, object > parameters)
| Exports a Project based on its ProjectInfo, list of ElevationInfo and parameters. More...
override ProjectInfo | RefreshChild (ProjectInfo childInfo)
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< LoginScope, ProjectCenterInfo, Project, ProjectInfo >
TOwnInfo | Refresh ()
virtual OperationInfo | CanEdit (string key, object value)
virtual TOwnInfo | Edit (string key, object value)

## Public Attributes
new LoginScopeUi | Parent => (LoginScopeUi) base.Parent
| The parent of this object. More...
Public Attributes inherited from Ofcas.Lk.Api.Client.Core.ProjectCenter
ProjectDirectoryInfo | OwnDirectoryInfo => _ownDirectoryInfo
| Returns the directory info for the project-center More...

## Protected Member Functions
override Project | CreateNewInstance (Guid coreObjectId, ProjectInfo childInfo)
Protected Member Functions inherited from Ofcas.Lk.Api.Client.Core.ProjectCenter
override IEnumerable< ProjectInfo > | GetChildrenInfos ()
Stream | ExportChild (ProjectInfo projectInfo, IEnumerable< ElevationInfo > elevationInfos, Dictionary< string, object > parameters, bool verbose)
Protected Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< LoginScope, ProjectCenterInfo, Project, ProjectInfo >
| CoreObjectFullyQualified (IServiceFactory< IApiService > serviceFactory, Guid coreObjectId, TParent parent, TOwnInfo ownInfo)
| Creates a new instance of CoreObjectFullyQualified<TParent,TOwnInfo,TChild,TChildInfo> with the given parameters. More...

## Additional Inherited Members
Properties inherited from Ofcas.Lk.Api.Client.Core.ProjectCenter
IList< ProjectDirectoryInfo > | ProjectDirectoryInfos`[get]`
Properties inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< LoginScope, ProjectCenterInfo, Project, ProjectInfo >
TParent | Parent`[get]`
TOwnInfo | Info`[get]`

## Detailed Description

ProjectCenterUi is the representation of a LogiKal project-center. The ProjectCenterUi provides methods with user interactions. The children are of type Project. The children can be received from the InfoList (CoreObjectWithChildren<TChild,TChildInfo>.ChildrenInfos). Each ProjectCenter project center belongs to a fixed directory. To use another project directory, create a new project center using method ProjectCenter.GetProjectCenter.

## Member Function Documentation

## ◆ CreateChild()

ProjectInfo Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.CreateChild | ( |  | ) |

Creates a new project with a default name and opens. Call Project.Edit with WellKnownEditKeys.Project.Name to change the name after the creation. Due to settings in LogiKal user interfaces can be shown.

Returns
  Returns an info object of the created project.

## ◆ CreateLkProject()

ProjectInfo Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.CreateLkProject | ( |  | ) |

This method is obsolete, please use CanCreateChild() and CreateChild() instead and use the project programs to open the UI. See WellKnownPrograms.Project.

Returns
  The ProjectInfo to the created project or NULL if the user rejected the dialog.

Exceptions

  Exception | Generating project failed or aborted.

## ◆ ExportChild() [1/2]

IDialogResult<Stream> Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.ExportChild | ( | ProjectInfo | projectInfo | ) |

Exports a Project based on its ProjectInfo via User Interface (UI).

Parameters

  projectInfo | The info of the project to be exported.

Returns
  Returns the stream of the exported project archive.

## ◆ ExportChild() [2/2]

new Stream Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.ExportChild | ( | ProjectInfo | projectInfo,
|  | IEnumerable< ElevationInfo > | elevationInfos,
|  | Dictionary< string, object > | parameters
| ) |  |

Exports a Project based on its ProjectInfo, list of ElevationInfo and parameters.

Parameters

  projectInfo | The info of the project to be exported.
  elevationInfos | The elevations to be exported.
  parameters | The parameters for the export.

Returns
  Returns the stream of the exported project archive.

## ◆ GetChild()

new ProjectUi Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.GetChild | ( | ProjectInfo | projectInfo | ) |

Gets a ProjectUi based on a ProjectInfo.

Parameters

  projectInfo | The ProjectInfo of the ProjectUi to be returned.

Returns
  Returns a ProjectUi based on the given ProjectInfo.

## ◆ GetProject()

new ProjectUi Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.GetProject | ( | ProjectInfo | projectInfo | ) |

This method is deprecated. Please use GetChild(ProjectInfo) instead.

## ◆ GetProjectCenter()

new ProjectCenterUi Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.GetProjectCenter | ( | ProjectDirectoryInfo | projectDirectoryInfo | ) |

Creates a new ProjectCenterUi for the given directory. Each ProjectCenterUi belongs to a fixed directory.

Parameters

  projectDirectoryInfo | The project directory to use

Returns
  The new ProjectCenterUi

Exceptions

  Exception | if creating project-center failed (for example invalid directory)

## ◆ Import()

ProjectInfo Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.Import | ( | ProjectCenterImportType | importType,
|  | Stream | content
| ) |  |

Import a Project via User Interface (UI).

Parameters

  importType | The type how to import a project (ProjectCenterImportType). The type influenced the content.
  content | the content depends to the given importType

Returns

## ◆ ImportChild()

IDialogResult<ProjectInfo> Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.ImportChild | ( | Stream | content | ) |

Imports a project from the provided content. It is possible to import a project with a *.LOB file (ExportChild. Additional formats to import are specified in the "Public API Documentation" (Confluence).

Returns
  Returns the ProjectInfo of the imported project after a successfull import or null after a failed import.

## ◆ SetApplicationHandle()

void Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.SetApplicationHandle | ( | IntPtr | uiHandle | ) |

Sets an ui handle. All opened user interfaces used this handle as parent. After an operation the default handle from the login scope will be used (ServiceProxyBase<TService,TCoreObject>.Login).

Parameters

  uiHandle | the ui handle to be used for opened user interfaces from this class.

## Member Data Documentation

## ◆ Parent

new LoginScopeUi Ofcas.Lk.Api.Client.Ui.ProjectCenterUi.Parent => (LoginScopeUi) base.Parent

The parent of this object.

The documentation for this class was generated from the following file:

- ProjectCenterUi.cs